#include "base.as"
#include "races.as"

bool pitstop_drivingTooFast = false;
racesManager races();

void createRaces()
{
	//races.showCheckPointInfoWhenNotInRace = true;
	// Add a RaceFinish callback
    races.setCallback("RaceFinish", on_raceFinish);  
	
	double[][] baja_race = 
		{
			{200.12, 8.65029, 269.016, 0, 64.0731, 0},
			{335.618, 13.1757, 179.265, 0, 91.9801, 0},
			{335.636, 13.1711, 179.309, 0, 92.3705, 0},
			{433.047, 8.19121, 169.174, 0, 84.1449, 0},
			{567.383, 12.0284, 239.344, 0, 117.595, 0},
			{680.246, 11.6194, 244.974, 0, 39.0512, 0},
			{740.645, 12.3035, 176.387, 0, 49.0475, 0},
			{856.064, 14.7126, 144.165, 0, 140.508, 0},
			{856.317, 14.6589, 144.597, 0, 140.921, 0},
			{700.339, 16.6448, 341.974, 0, -130.353, 0},
			{636.354, 11.7407, 425.055, 0, -145.278, 0},
			{555.248, 8.42144, 521.665, 0, -110.318, 0},
			{453.123, 10.9879, 461.454, 0, -65.943, 0},
			{311.695, 8.86693, 377.939, 0, -59.5213, 0},
			{194.62, 9.16148, 313.333, 0, -53.7963, 0}
		};
	int myRaceID = races.addRace("Baja race", baja_race, races.LAPS_NoLaps, "31-checkpoint", "31-checkpoint", "31-checkpoint", "unknown_author-1.0");
	
	races.setVersion(raceID, "unknown_author-1.0");
	races.finalize(raceID);

	// add a cancel point for all races (we can do this for all races by setting the race ID to -1)
	double[][] cancelpoint = {{965, 8.8, 580, 0, 90, 0,}};
	races.addCancelPoint(-1, "31-trigger10x10", cancelpoint[0], on_cancelPoint);
}

// The default RoR main function
void main()
{
	createRaces();
	//races.submitScore(false);
	// add the pitstop event
	//game.spawnObject("trucktrigger", "pitstop", vector3(883.356262f, 0.340250f, 1302.838745f), vector3(0.000010f, 0.000000f, 0.000000f), "PitStopEvent", false);	
}

// The default RoR event callback
void eventCallback(int eventnum, int value)
{
	// required for the races!
	races.eventCallback(eventnum, value);
}

// the event callback for our cancelpoint
void on_cancelPoint(dictionary@ info)
{
	game.flashMessage("Race aborted.", 4, -1);
}

// The event callback for finishing a race
void on_raceFinish(dictionary@ info)
{
    // Get the race ID
    int raceID;
    info.get("raceID", raceID);
    
    // get the lap time (in seconds)
    float lapTime = game.getTime() - races.lapStartTime;
    
    // get the race time (in seconds)
    float raceTime = game.getTime() - races.raceStartTime;
    
    // Race specific stuff
}  